//+-------------------------------------------------------------------------------------------+
//|                                                                     FXParaziteScalper.mq4 |
//|                                                             Copyright  2008, FOREXflash. |
//|                                                                 http://www.metaquotes.net |
//+-------------------------------------------------------------------------------------------+
#property copyright "Copyright  2008, FOREXflash"
#property link      "http://www.metaquotes.net"
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh> 
//+-------------------------------------------------------------------------------------------+

extern string __MAIN_FUNCTIONS_____;
extern int      Slippage           = 3;
extern int      MagicNumber        = 1803;
extern int      Risk_percent       = 5;
extern double   minLots            = 0.1;
extern double   maxLots            = 5;
extern string __TP\SL_FUNCTION_____; 
extern double   StopLoss           = 25;    
extern double   TakeProfit         = 150; 
extern string __MOVE_STOPS_FUNCTION_____; 
extern bool     Move_Stops         = true;
extern int      First_Stop_Target  = 25;
extern int      First_Stop         = 5;
extern int      Second_Stop_Target = 50;
extern int      Second_Stop        = 25;
extern int      Third_Stop_Target  = 75;
extern int      Third_Stop         = 50;
extern int      Fourth_Stop_Target = 100;
extern int      Fourth_Stop        = 75;
extern int      Fifth_Stop_Target  = 125;
extern int      Fifth_Stop         = 100;
extern string __TRADING_HOURS_LIMIT_____;
extern int      iStartTradingHour  = 0;
extern int      iEndTradingHour    = 24;
extern string __MA_TREND_FILTER_____;
extern int      maPeriod           = 50;
extern string __BOLINGER_BANDS_TRIG_____;
extern int      BBperiod           = 20;
extern string __MAIN_FILTERS_____;
extern int      MACD_Fast = 8;
extern int      MACD_Slow = 17;
extern int      MACD_Signal = 9; 
extern int      RSI = 14;
extern int      Momentum = 14;
extern int      DeMarker = 14;
extern int      ADX = 14;
extern int      ForceIndex = 14;

//+-------------------------------------------------------------------------------------------+

double BBUPPER;
double BBLOWER;
double CCI;
//---- 
double  MACD;
double  MACD_Sig;
//---- 
double  ADX1;
double  ADX2;
//----
double  RSIV;
double  DEM; 
double  MOM; 
double  FI;


  
int             Buy_signal1=0;       
int             StartHour = 0;
double          Lots=0.1;
int             Bar_Count=0;
extern int      OrderRetries = 5;
extern int      SleepBetweenTrades = 1000;
int             ticket_buy;
int             ticket_sell;
string          strSymbol;
string          strComment="FXParazite by FOREXflash";
color           BuyArrow=Lime;
color           SellArrow=Red;
string          only_demo_accounts = "";
int             Prev_Order=-1;
datetime        Check_period=0;
datetime        Checked_period=0;
bool            longs=true;
bool            shorts=true;
bool            result =false;
string          trendType;
int             timeFrame = 0;
int             nextTP;
bool            sl;
int             range = 5;
int             multiplier;

//+-------------------------------------------------------------------------------------------+
//| check license                                                                             |
//+-------------------------------------------------------------------------------------------+
bool Check_Licence()
{
     
   if (IsDemo() == false) {
      Alert(strComment + ". Only demo accounts allowed.");
      result = false;
   }
   return(result);
}

//+-------------------------------------------------------------------------------------------+
//| expert initialization function                                                            |
//+-------------------------------------------------------------------------------------------+

int init()
  {
//----
    sl=0;
    
    ObjectCreate("lblTrendType",OBJ_LABEL,0,0,0,0,0);
    ObjectSet("lblTrendType",OBJPROP_XDISTANCE,5);
    ObjectSet("lblTrendType",OBJPROP_YDISTANCE,100);
    ObjectSetText("lblTrendType","TrendType",14,"Tahoma",Red);
//----
   return(0);
  }
  
//+-------------------------------------------------------------------------------------------+
//| expert deinitialization function                                                          |
//+-------------------------------------------------------------------------------------------+

int deinit()
  {
//---- 
   sl=0;
   ObjectsDeleteAll();
//----
   return(0);
  }
  
//+-------------------------------------------------------------------------------------------+
//| Trend analize                                                                               |
//+-------------------------------------------------------------------------------------------+
 
void MarketAnalize()
{

  int ma = iMA(Symbol(),0,maPeriod,0,MODE_EMA,PRICE_OPEN,0);
  
  if(Open[0]>ma)
  {
    trendType = "Bullish";
  }
  if(Open[0]<ma)
  {
    trendType = "Bearish";
  }
  ObjectSetText("lblTrendType",trendType);
  }
//+------------------------------------------------------------------+
//|  GoldenFilter_v1                                                 |
//+------------------------------------------------------------------+
int FILTERS()
  {

       double  RSIV =iRSI(NULL,0,RSI,PRICE_CLOSE,0);
       double  CCI =iCCI( NULL, 0, 5, PRICE_TYPICAL, 0);
       //---- 
       double  MACD = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
       double  MACD_Sig = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow,MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
                                
       //---- 
       double  ADX1 = iADX(NULL, 0, ADX, PRICE_CLOSE, MODE_PLUSDI, 0);
       double  ADX2 = iADX(NULL, 0, ADX, PRICE_CLOSE, MODE_MINUSDI, 0);
       //----

       double  DEM = iDeMarker(NULL, 0, DeMarker, 0); 
       double  MOM = iMomentum( NULL,0, Momentum, PRICE_CLOSE, 0); 
       double  FI = iForce(NULL, 0, ForceIndex, 1, PRICE_CLOSE, 0);
            
       if ( (RSIV>65) && (CCI>100) &&(MOM > 100) && (DEM > 0.5 && FI >0) && (MACD > MACD_Sig && ADX1 > ADX2))
       {
       return (1);
       }
       if ( (RSIV<35) && (CCI<-100) &&(MOM <= 100) && (DEM < 0.5 < 50 && FI < 0) && (MACD < MACD_Sig && ADX1 < ADX2))  
       {
       return (-1);
       }
       
       return(0);	
       }
//+-------------------------------------------------------------------------------------------+
//| expert start function                                                                     |
//+-------------------------------------------------------------------------------------------+

int start()
{
int totalorders = OrdersTotal();
for(int j=0; j<totalorders;j++)
{
OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
if (OrderSymbol() == Symbol() && OrderType() > 1)
{
if(OrdersTotal()<=3)EndSession();
if(OrdersTotal()>4)EndSession();
}
}
MarketAnalize();
Check_Licence();
getOpenOrders();
getSpread();
FILTERS();

double BBUPPER =iBands(NULL,0,BBperiod,1,0,PRICE_CLOSE,MODE_UPPER,1);
double BBLOWER =iBands(NULL,0,BBperiod,1,0,PRICE_CLOSE,MODE_LOWER,1);

//+-------------------------------------------------------------------------------------------+

int i=0,k=0,sec=0;   
int Insider, Insider2;
int Black_insider, White_insider, White_bird, Black_bird;
int Buy_signal=0;
int Confirm_buy;
int Confirm_sell;
int Sell_signal=0;
int Downer=0;
int Upper=0;
double Zig_level_buy;
double Zig_level_sell;
string i_n;
string loss_filename, win_filename, month, day, ticket_id;  
double max_price;
double min_price;
strSymbol=Symbol();

// Defining the variables to decide.

       
     if (High[1]<=High[2] && Low[1]>=Low[2] && Close[1]<=Open[1])
       {Black_insider=1;}else {Black_insider=0;}
       
     if (High[1]<=High[2] && Low[1]>=Low[2] && Close[1]>Open[1])
       {White_insider=1;}else {White_insider=0;}
 
     if (White_insider==1 && Close[2]>Open[2])
       {White_bird=1;}else {White_bird=0;}       
      
     if (Black_insider==1 && Close[2]<Open[2])
       {Black_bird=1;}else {Black_bird=0;}              
       
 
if (Open[1]<Close[1])
{Zig_level_buy=(Close[1]-(Close[1]-Open[1])/3);}//White
else
{Zig_level_buy=(Close[1]-(Close[1]-Low[1])/3);}//Black
 
if (Open[1]>Close[1])
{Zig_level_sell=(Close[1]+(Open[1]-Close[1])/3);}//Black
else
{Zig_level_sell=(Close[1]+(High[1]-Close[1])/3);}//White
 
 
if ( ((Low[0]<=Zig_level_buy) || (Hour()>=StartHour)) 
&&(Black_bird==0) && (White_insider==0))
{Confirm_buy=1;}else{Confirm_buy=0;}
 
if ( ((High[0]>=Zig_level_sell) || (Hour()>=StartHour))
&& (White_bird==0) && (Black_insider==0))
{Confirm_sell=1;}else{Confirm_sell=0;}
 
 
if (High[0]>High[1])
{Buy_signal=1;}else {Buy_signal=0;}
 
if (Buy_signal==1)
{
i++;
max_price=High[i];
while (max_price<High[i+1])
{
max_price=High[i+1];
i++;
}
}
  
if (Low[0]<Low[1])
{Sell_signal=1;}else {Sell_signal=0;}
 
if (Sell_signal==1)
{
k++;
min_price=Low[k];
while (min_price>Low[k+1])
{
min_price=Low[k+1];
k++;
}
}
  
//+-------------------------------------------------------------------------------------------+
//| expert buy                                                                                |
//+-------------------------------------------------------------------------------------------+
 
if (Buy_signal==1)
{

      Call_MM();
      if (longs==false&&iVolume(Symbol(),0,0)<=1) longs=true;
      if (Hour() <= iStartTradingHour || Hour() >= iEndTradingHour) return;
      if (Confirm_buy==1)
      if (OpenTradesForMN(MagicNumber)==0)
      if (trendType=="Bullish")
      if (High[1]>=BBUPPER)
      if (FILTERS() == 1)
      {

      ticket_buy=OpenAtMarket(strSymbol,OP_BUY,Lots,StopLoss,TakeProfit,strComment,MagicNumber,0,BuyArrow, OrderRetries, SleepBetweenTrades);  
      OrderSend(Symbol(),OP_BUYSTOP,Lots,Ask+Second_Stop*Point,2,Ask - StopLoss * Point,Ask + TakeProfit * Point,DoubleToStr(Ask,MarketInfo(Symbol(),MODE_DIGITS)),MagicNumber,0,Blue);
      OrderSend(Symbol(),OP_BUYSTOP,Lots,Ask+Third_Stop*Point,2,Ask - StopLoss * Point,Ask + TakeProfit * Point,DoubleToStr(Ask,MarketInfo(Symbol(),MODE_DIGITS)),MagicNumber,0,Blue);
      OrderSend(Symbol(),OP_BUYSTOP,Lots,Ask+Fourth_Stop*Point,2,Ask - StopLoss * Point,Ask + TakeProfit * Point,DoubleToStr(Ask,MarketInfo(Symbol(),MODE_DIGITS)),MagicNumber,0,Blue);      
      
      longs = false;

      if (StringLen(DoubleToStr(ticket_buy,0))==1)
      ticket_id="0"+ticket_buy;
      else
      ticket_id=ticket_buy;

      Prev_Order=1;
     }
   }
 {   
}

//+-------------------------------------------------------------------------------------------+
//| expert sell                                                                               |
//+-------------------------------------------------------------------------------------------+ 

if (Sell_signal==1)
{
   Call_MM();
   if (shorts==false&&iVolume(Symbol(),0,0)<=1) shorts=true;
   if (Hour() <= iStartTradingHour || Hour() >= iEndTradingHour) return;
   if (Confirm_sell==1)
   if (OpenTradesForMN(MagicNumber)==0)
   if (trendType=="Bearish")
   if (Low[1]<=BBLOWER)
   if (FILTERS() == -1)
   {

   ticket_sell=OpenAtMarket(strSymbol,OP_SELL,Lots,StopLoss,TakeProfit,strComment,MagicNumber,0,SellArrow, OrderRetries, SleepBetweenTrades);
   OrderSend(Symbol(),OP_SELLSTOP,Lots,Ask-Second_Stop*Point,2,Bid + StopLoss * Point,Bid - TakeProfit * Point,DoubleToStr(Ask,MarketInfo(Symbol(),MODE_DIGITS)),MagicNumber,0,Red);
   OrderSend(Symbol(),OP_SELLSTOP,Lots,Ask-Third_Stop*Point,2,Bid + StopLoss * Point,Bid - TakeProfit * Point,DoubleToStr(Ask,MarketInfo(Symbol(),MODE_DIGITS)),MagicNumber,0,Red);
   OrderSend(Symbol(),OP_SELLSTOP,Lots,Ask-Fourth_Stop*Point,2,Bid + StopLoss * Point,Bid - TakeProfit * Point,DoubleToStr(Ask,MarketInfo(Symbol(),MODE_DIGITS)),MagicNumber,0,Red);
   
   shorts = false; 
   
   if (StringLen(DoubleToStr(ticket_sell,0))==1)
   ticket_id="0"+ticket_buy;
   else
   ticket_id=ticket_sell;
   
   Prev_Order=1;
   }
  }
return(0);
}

//+-------------------------------------------------------------------------------------------+
//| count orders                                                                              |
//+-------------------------------------------------------------------------------------------+
int OpenTradesForMN(int iMN)
{
int icnt, itotal, retval;

retval=0;
itotal=OrdersTotal();

   for(icnt=0;icnt<itotal;icnt++)
     {
      OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL)  
        {
         if(OrderMagicNumber()==iMN)
         {
           retval++;
         }
       }
     }
   return(retval);
 }

//+-------------------------------------------------------------------------------------------+
//| error logic                                                                               |
//+-------------------------------------------------------------------------------------------+

int OpenAtMarket (string strPair, int iOrderType, double dLots, int iStopLossPips, int iTakeProfitPips, string strOrderComment, int iMagicNumber, datetime dtExpiry, color cColour, int iNR, int iMTS)
{
 int iMaxNumRetries, iNumRetries=iNR;
 double dPrice, dSL, dTP;
 
    // is server or context busy - try n times to submit the order
    iNumRetries=iNR;
    
     if(iOrderType > OP_SELL)
      {
        Print("OpenAtMarket Error: OrderType is a Pending Order!");
        return(0);
      }
     
    while(iNumRetries>0)
    {
        RefreshRates();
        if(iOrderType==OP_BUY) 
          {
           dPrice=NormalizeDouble(Ask, Digits);
           dSL=NormalizeDouble(dPrice-iStopLossPips*Point, Digits);
           dTP=NormalizeDouble(dPrice+iTakeProfitPips*Point, Digits);
          }
          
        if(iOrderType==OP_SELL) 
           {
            dPrice=NormalizeDouble(Bid, Digits);
            dSL=NormalizeDouble(dPrice+iStopLossPips*Point, Digits);
            dTP=NormalizeDouble(dPrice-iTakeProfitPips*Point, Digits);           
           }
    
        int iTicket =  OrderSend(strPair, iOrderType, dLots, dPrice, Slippage, dSL, dTP, strOrderComment, iMagicNumber, dtExpiry, cColour);
 
        iNumRetries--;
 
        if(iTicket == -1 )
        {
            int iError = GetLastError();
 
            // retry if error is "busy", otherwise give up
            if(iError==ERR_SERVER_BUSY || iError==ERR_TRADE_CONTEXT_BUSY || iError==ERR_BROKER_BUSY || iError==ERR_NO_CONNECTION 
            || iError==ERR_TRADE_TIMEOUT || iError==ERR_INVALID_PRICE || iError==ERR_OFF_QUOTES || iError==ERR_PRICE_CHANGED || iError==ERR_REQUOTE)
                Sleep(iMTS);
            else
            {
                iNumRetries = 0;
                Print("OpenAtMarket: OrderSend Error ", iError );
            }
        }
        else
            iNumRetries = 0;
    }
 
    return(iTicket);
}

//+-------------------------------------------------------------------------------------------+
//| call moneymanagment                                                                       |
//+-------------------------------------------------------------------------------------------+
void Call_MM()
{
   Lots=AccountFreeMargin()/100000*Risk_percent;

   Lots=MathMin(maxLots,MathMax(minLots,Lots));
   if(minLots<0.1) 
     Lots=NormalizeDouble(Lots,2);
   else
     {
     if(minLots<1) Lots=NormalizeDouble(Lots,1);
     else          Lots=NormalizeDouble(Lots,0);
     }
     
   return(0);
}

//+-------------------------------------------------------------------------------------------+
//| trail jumps                                                                               |
//+-------------------------------------------------------------------------------------------+
double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point;
   return(val);   
}
//== end function

int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   return(spread);
}

//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {  
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && OrderSymbol() == Symbol()&&(MagicNumber==0 || MagicNumber == OrderMagicNumber()))
         {

            double val=getPipValue(OrderOpenPrice(),OrderType());
            if(Move_Stops) checkStops(val,OrderTicket());         
            
         }
         
         if(MagicNumber == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+MagicNumber;
         
         
         if(sl==0)
            {
               nsl = First_Stop_Target;
               nsd = First_Stop;
            }
          else
            {
               nsl = Second_Stop_Target;
               nsd = Second_Stop;
            }
         //RefreshRates();
         Comment("Order Open: ",OrderOpenPrice(), 
         "\nPip Count: ", val,
         "\nNext Stop Target: ",nsl,
         "\nNext Stop Differential: ", nsd,
         "\nNext TP: ", nextTP,
         "\nSL: ",sl,
         "\nManaging: ",mngMagic);
  }  
}

//========== FUNCTION moveStops
void checkStops(int pips,int ticket)
{
   if(sl==0 && pips < Second_Stop_Target)
   {
      if(pips >= First_Stop_Target && pips < (Second_Stop_Target))
      {
         moveStops(ticket, First_Stop);
      }
   }
   else if(sl==1 || pips >= Second_Stop_Target)
   {
      if(pips >= Second_Stop_Target)
      {
         moveStops(ticket,Second_Stop);
      }
   }
   else if(sl==1 || pips >= Third_Stop_Target)
   {
      if(pips >= Third_Stop_Target)
      {
         moveStops(ticket,Third_Stop);
      }
   }
   else if(sl==1 || pips >= Fourth_Stop_Target)
   {
      if(pips >= Fourth_Stop_Target)
      {
         moveStops(ticket,Fourth_Stop);
      }
   }
   else if(sl==1 || pips >= Fifth_Stop_Target)
   {
      if(pips >= Fifth_Stop_Target)
      {
         moveStops(ticket,Fifth_Stop);
      }
   }
}

//========== FUNCTION moveStops
void moveStops(int ticket,int stopDiff)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      Print("moveStops called ",ticket, " ",stopDiff);
      if(OrderType()==1) 
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-stopDiff*Point, OrderTakeProfit(),0,Plum);
      sl=1;
      }
      else 
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+stopDiff*Point, OrderTakeProfit(),0,Plum);
      sl=1;
      }
   }  
}
//+-------------------------------------------------------------------------------------------+
//| Close all if num of trades is less than 4                                                 |
//+-------------------------------------------------------------------------------------------+
bool EndSession()
   {
      int totalorders = OrdersTotal();
      
      for(int n=totalorders-1;n>=0;n--)
         {
            OrderSelect(n, SELECT_BY_POS);
            bool result = false;
            
            if ( OrderMagicNumber() == MagicNumber ) 
               {
                  //Close opened long positions
                  if ( OrderType() == OP_BUY )result= OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, White );
                  //Close opened short positions
                  if ( OrderType() == OP_SELL )result=  OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, White );
                  //Close pending orders
                  if ( OrderType() > 1 )result=  OrderDelete( OrderTicket() );
               }
         }
       
      return(result);
   }  

